// O(n x n)
#include<fstream>
#define inFile  "maxp.in"
#define outFile "maxp.out"
#define dim 200001

using namespace std;

int a[dim], st[dim], dr[dim], n;

int main()
{
	int i, k, nrsol;
	long long p, pmax;
	//citire
	ifstream fin(inFile);
	fin >> n;
	for (i = 1; i <= n; i++)
		fin >> a[i];
	a[0] = 5000000;
	a[n + 1] = 5000000;
	fin.close();
	
	// constructie st
	st[1] = 0;
	for (i = 2; i <= n; i++)
		if (a[i - 1] > a[i]) st[i] = 0;
		else 
		{
			k = i - 1;
			while (a[k] < a[i])
				k--;
			st[i] = i - k - 1;
		}
	
	// constructie dr
	dr[n] = 0;
	for (i = n - 1; i >= 1; i--)
		if (a[i] < a[i + 1]) dr[i] = 0;
		else 
		{
			k = i + 1;
			while (a[i] > a[k])
				k++;
			dr[i] = k - i - 1;
		}
	
	// calcul
	nrsol = 1;
	pmax = (st[1] + 1);
	pmax *= (dr[1] + 1);
	for (i = 2; i <= n; i++)
	{
		p = (st[i] + 1);
		p = (p * (dr[i] + 1));
		if (p > pmax)
		{
			pmax = p;
			nrsol = 1;
		}
		else if (p == pmax) nrsol++;
	}
	
	ofstream fout(outFile);
	fout << pmax << "\n" << nrsol << "\n";
	fout.close();
	
	return 0;
}
