// profesor Szabo Zoltan ISJ Mures
#include <fstream>

using namespace std;
int a[1003][1003];    // declar tabla de sah variabila globala, ca sa fie initializata cu 0
int main()
{   int N,D,K,d[2][100],i,j,maxalbe,albe,x,y,atacate,l,c;
    ifstream fin("betasah.in");
    ofstream fout("betasah.out");
    fin>>N>>D>>K;     //  dimensiunea tablei N, numarul damelor D si numarul patratelor gri K
    for (i=0;i<D;++i)
    {
        fin>>x>>y;    //  citesc pozitiile damelor
        d[0][i]=x;
        d[1][i]=y;
        a[x][y]=1;    // 1 pe tabla de sah va insemna dama
    }
    for (i=0;i<K;++i)
    {
        fin>>x>>y;    //  citesc pozitiile patratelor gri
        a[x][y]=-1;   //  -1 pe tabla de sah va insemna patrat gri
    }

    maxalbe=0;        // maxalbe contine numarul maxim de patrate albe de pe un rand
    for (i=1;i<=N;++i)
    {
        albe=0;       // in "albe" vom numara numarul patratelor albe de pe randul i
        for(j=1;j<=i;++j)
            albe+=(a[i][j]!=-1); // daca a[i][j] difera de -1, atunci e patrat alb,
                                // deci conditia are valoarea 1
        if (albe>maxalbe) maxalbe=albe;
    }

    atacate=0;       // numarul campurilor atacate de dame
    for (i=0;i<D;++i)
    {
        l=d[0][i];
        c=d[1][i];
        // directia verticala-sus
        while (l>=c && a[l][c]!=-1)
        {
            if (a[l][c]==0)
            {
                ++atacate; // se numara orice camp nenumarat
                a[l][c]=1; //
            }
            --l;
        }

        l=d[0][i];
        c=d[1][i];
        // directia oblic dreapta-sus
        while (l>=c && a[l][c]!=-1)
        {
            if (a[l][c]==0)
            {
                ++atacate; // se numara orice camp nenumarat
                a[l][c]=1; //
            }
            --l;
            ++c;
        }

        l=d[0][i];
        c=d[1][i];
        // directia orizontala-dreapta
        while (l>=c && a[l][c]!=-1)
        {
            if (a[l][c]==0)
            {
                ++atacate; // se numara orice camp nenumarat
                a[l][c]=1; //
            }
            ++c;
        }

        l=d[0][i];
        c=d[1][i];
        // directia oblic dreapta-jos
        while (l<=N && a[l][c]!=-1)
        {
            if (a[l][c]==0)
            {
                ++atacate; // se numara orice camp nenumarat
                a[l][c]=1; //
            }
            ++l;
            ++c;
        }


        l=d[0][i];
        c=d[1][i];
        // directia verticala-jos
        while (l<=N && a[l][c]!=-1)
        {
            if (a[l][c]==0)
            {
                ++atacate; // se numara orice camp nenumarat
                a[l][c]=1; //
            }
            ++l;
        }

        l=d[0][i];
        c=d[1][i];
        // directia oblic stanga-jos
        while (l<=N && c>0 && a[l][c]!=-1)
        {
            if (a[l][c]==0)
            {
                ++atacate; // se numara orice camp nenumarat
                a[l][c]=1; //
            }
            ++l;
            --c;
        }

        l=d[0][i];
        c=d[1][i];
        // directia orizontala-dreapta
        while (c>0 && a[l][c]!=-1)
        {
            if (a[l][c]==0)
            {
                ++atacate; // se numara orice camp nenumarat
                a[l][c]=1; //
            }
            --c;
        }

        l=d[0][i];
        c=d[1][i];
        // directia oblic-stanga-sus
        while (c>0 && a[l][c]!=-1)
        {
            if (a[l][c]==0)
            {
                ++atacate; // se numara orice camp nenumarat
                a[l][c]=1; //
            }
            --c;
            --l;
        }
    }


    fout <<maxalbe<<endl<<atacate<< endl;
    fin.close();
    fout.close();
    return 0;
}
