#include <iostream>
#include <fstream>
#include <vector>
#include <string>
#include <algorithm>
using namespace std;

const char iname[] = "subsecvente.in";
const char oname[] = "subsecvente.out";

typedef unsigned long long i64;


void read_in(string &main_str, vector <string> &strs) {
    ifstream fin(iname);
    int n; fin >> n;
    
    fin >> main_str;
    for (string str; fin >> str; )
        strs.push_back(str);
    fin.close();
}

void write_out(int length) {
    ofstream out(oname);
    out << length << "\n";
    out.close();
}

bool search_string(string& str, vector <string>& strs) {
    for (size_t i = 0; i < strs.size(); ++ i) {
        if (strs[i].find(str) == string::npos)
            return false;
    }
    return true;
}

int main(void) {
    string main_str; vector <string> strs;
    read_in(main_str, strs);

    int delta = 64, k = 0;
    for (; delta > 0; delta >>= 1) {
        int length = k + delta;
        if (length > 61)  continue;

        for (int i = 0; i <= (int)main_str.size() - length; ++ i) {
            string number_str = main_str.substr(i, length);
            if (search_string(number_str, strs)) {
                k = length;
                break;
            }
        }
    }
    write_out(k);
    
    return 0;
}