#include <iostream>
#include <fstream>
#include <vector>
#include <string>
#include <algorithm>
using namespace std;

const char iname[] = "subsecvente.in";
const char oname[] = "subsecvente.out";

typedef unsigned long long i64;


void read_in(string &main_str, vector <string> &strs) {
    ifstream fin(iname);
    int n;  fin >> n;
    fin >> main_str;
    for (string str; fin >> str; )
        strs.push_back(str);
    fin.close();
}

void write_out(int length) {
    ofstream out(oname);
    out << length << "\n";
    out.close();
}

bool search_string(string& str, vector <string>& strs) {
    for (size_t i = 0; i < strs.size(); ++ i) {
        if (strs[i].find(str) == string::npos)
            return false;
    }
    return true;
}

int main(void) {
    string main_str; vector <string> strs;
    read_in(main_str, strs);

    string number_ans;
    for (size_t i = 0; i < main_str.size(); ++ i) {
        for (size_t j = i; j < main_str.size(); ++ j) {
            string number_str = main_str.substr(i, j-i+1);
            if (search_string(number_str, strs)) {
                if (number_ans.size() < number_str.size())
                    number_ans = number_str;
            }
        }
    }
    write_out(number_ans.size());
    return 0;
}