#include <fstream>
#include <iostream>
#include <sstream>
#include <string>
#include <cstdlib>
using namespace std;


ifstream fok("bete.ok");
ifstream fout("bete.out");

void Msg(int pct, string msg );
string Trim(string s);

int main(int argc, char* argv[])
{
    if ( !fout )
        Msg(0, "Nu exista fisierul bete.out!");

    int testNumber, testPoints;

	testNumber =  atoi(argv[1]);          // numarul testului
	testPoints =  atoi(argv[2]);          // nr puncte/test

    int total = 0,t1=0,t2=0,t3=0;    // punctajul total
    bool ok1 = false, ok2 = false,ok3=false;

	// trei cerinte
    string a, b,c;     // valori corecte
    string x, y,z;     // valorile concurentului
	getline(fok, a);  a = Trim(a);         // elimin spatiile de la sfarsit
	getline(fok, b);  b = Trim(b);
    getline(fok, c);  c = Trim(c);

	getline(fout, x); x = Trim(x);
	if ( a == x )
    {
        t1= (testPoints * 30) / 100;  // 30 % din punctajul pe test
        ok1 = true;
    }

	getline(fout, y);  y = Trim(y);
    if ( b == y )
    {
        t2= (testPoints * 30) / 100; // 30 % din punctaj
        ok2 = true;
    }

    getline(fout, z);  z = Trim(z);
    if ( c == z )
    {
        t3= (testPoints * 40) / 100; // 40 % din punctaj
        ok3 = true;
    }

    if ( ok1 && ok2&&ok3 )
       Msg(t1+t2+t3, "Corect !");
    if (!ok1 && !ok2&&!ok3)
        Msg(total, "Incorect !" );
    if ( ok1&&ok2 )
        Msg(t1+t2, "Valoare incorecta cerinta 3 !");
    if ( ok1&&ok3 )
        Msg(t1+t3, "Valoare incorecta cerinta 2 !");
   if ( ok2&&ok3 )
        Msg(t2+t3, "Valoare incorecta cerinta 1 !");
    if ( ok1 )
        Msg(t1, "Valoare incorecta cerinta 2 si cerinta 3 !");
    if ( ok2 )
        Msg(t2, "Valoare incorecta cerinta 1 si cerinta 3 !");
    if ( ok3 )
        Msg(t1, "Valoare incorecta cerinta 1 si cerinta 2 !");
    return 0;
}

void Msg(int pct, string msg )
{
    cout << pct << ' ' << msg;
    try
    {
        fok.close();
        fout.close();
    }
    catch (string ex) {}
    exit(0);
}

string Trim(string str)
{
	size_t pos = str.find_last_not_of(" \t");
	if ( pos != string::npos )
		str = str.substr(0, pos + 1);
	return str;
}
